* Create the database by copying it from the sample data.

close databases
if not MAKESAMP()
	return .F.
endif not MAKESAMP()

* Create a PRG with some stored procedure code.

text to lcProc noshow

procedure GetTotalSalesByCustomer(tcCustID)
select sum(Order_Amt) as TotalSales ;
	from Orders ;
	where Cust_ID = tcCustID ;
	into cursor Sales
return TotalSales

endtext
strtofile(lcProc, 'TEMP.PRG')

* Open the TESTDATA DBC, append the PRG to the stored procedures, and nuke the
* PRG.

open database 'Data\Testdata.DBC'
append procedures from temp.prg overwrite
erase temp.prg
close databases

* Now let's check it out.

local loConn as ADODB.Connection, ;
	loRS as ADODB.RecordSet, ;
	loCommand as ADODB.Command
loConn    = createobject('ADODB.Connection')
loCommand = createobject('ADODB.Command')
loConn.ConnectionString = 'Provider=vfpoledb;Data Source=' + ;
	fullpath('Data\Testdata.DBC')
loConn.Open()
loCommand.ActiveConnection = loConn
loCommand.CommandType      = 8  && adCmdUnknown
loCommand.CommandText      = "GetTotalSalesByCustomer('ALFKI')"
loRS = loCommand.Execute()
wait window 'Total sales for ALKFI: ' + transform(loRS.Fields('Return_Value').Value)
loConn.Close()
